      SUBROUTINE  SFTRN4(IFUNCT)
C     (SFTRN4)
C     EWM  SFTRN4:  Analysis of all SFTRAN statements except DO, IF,
C     EWM           and END.
C     NHFB - Add UNDENT=999 in PROCEDURE ('STOP' or 'RETURN')  to
C            get exit arrows  out to  line number  field in  left
C            margin of structured FORTRAN listing (and fix IOFUNC
C            to handle large UNDENT).
C     (24-FEB-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CLOGNX,      CNAMNX,      DCODE,       DOCYCL
C     EXTERNAL REFS       DOEXIT,      GIFLOG,      GIFNLG,      GNAMNO
C     EXTERNAL REFS       GOTOS2,      IOFUNC,      OPNCNT,      OSFLST
C     EXTERNAL REFS       OSFRFL,      PRRDWR,      SCANER,      SFTERR
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      LOGICAL             DCODE,       SCANER
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CCNUM,       LJUNK
C
      INTEGER             CASENO,      CCNUM,       DUMMY,       IFUNCT
      LOGICAL             LJUNK
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM01  /
C
      INTEGER             BYTE,        CC,          CCLABL
      INTEGER             CCMORE,      IN,          INDENT
      INTEGER             LLABL,       MLABL
      INTEGER             NHELD,       OUT
      INTEGER             UNDENT
      LOGICAL             EOF,         FIRST,       LABEL,       LAST
      LOGICAL             MORE
C
      COMMON / COM01  /   BYTE,        CC,          CCLABL
      COMMON / COM01  /   CCMORE,      EOF,         FIRST,       IN
      COMMON / COM01  /   INDENT,      LABEL,       LAST
      COMMON / COM01  /   LLABL,       MLABL,       MORE
      COMMON / COM01  /   NHELD
      COMMON / COM01  /   OUT,         UNDENT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM02  /
C
      INTEGER             CCFLGS,      CCLIST,      CCNAME,      CCRW
      INTEGER             DEFNO,       INDEXS,      LFLGS,       LLIST
      INTEGER             LLOGS,       MAXLEV,      NEXT
C
      COMMON / COM02  /   CCFLGS(2),   CCLIST,      CCNAME,      CCRW
      COMMON / COM02  /   DEFNO,       INDEXS(38,39)
      COMMON / COM02  /   LFLGS(2),    LLIST,       LLOGS(2)
      COMMON / COM02  /   MAXLEV,      NEXT
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM03  /
C
      INTEGER             CASES,       CCINDX,      CCLOG,       CCLOGS
      INTEGER             LINDX,       LLOG
      INTEGER             MINDX,       NFND,        NONE
      INTEGER             NSTACK,      S1STAK,      SFNMBR
      LOGICAL             BLANK,       FOUND,       NOFLOW,      NONMBR
      LOGICAL             XLATED
C
      COMMON / COM03  /   BLANK,       CASES(39),   CCINDX,      CCLOG
      COMMON / COM03  /   CCLOGS(2),   FOUND,       LINDX
      COMMON / COM03  /   LLOG,        MINDX
      COMMON / COM03  /   NFND,        NOFLOW,      NONE,        NONMBR
      COMMON / COM03  /   NSTACK,      S1STAK(39),  SFNMBR
      COMMON / COM03  /   XLATED
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM05  /
C
      INTEGER             BLANKS,      LEFT,        LEVEL
      INTEGER             RIGHT,       S0,          S1,          STRCTS
      COMMON / COM05  /   BLANKS(92),  LEFT,        LEVEL
      COMMON / COM05  /   RIGHT,       S0,          S1
      COMMON / COM05  /   STRCTS(39)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM06  /
C
      INTEGER             F4KEY,       HOLDIO,      INSF,        LINE
      INTEGER             LINENO,      MAXIN,       MDATA,       OUTERR
      INTEGER             OUTF4,       OUTSF,       P2BASE,      PBASE
      INTEGER             SBASE,       SFKEY,       SPACES,      TEMPF4
      LOGICAL             ERRORS
      COMMON / COM06  /   ERRORS,      F4KEY,       HOLDIO,      INSF
      COMMON / COM06  /   LINE,        LINENO,      MAXIN,       MDATA
      COMMON / COM06  /   OUTERR,      OUTF4,       OUTSF,       P2BASE
      COMMON / COM06  /   PBASE,       SBASE,       SFKEY,       SPACES
      COMMON / COM06  /   TEMPF4
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM07  /
C
      INTEGER             S1PNDG,      S2
      LOGICAL             EXITS,       FND,         OTHERS
C
      COMMON / COM07  /   EXITS(39),   FND,         OTHERS(39),  S1PNDG
      COMMON / COM07  /   S2
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM10  /
C
      INTEGER             L0,          L1STAK,      LBASE
C
      COMMON / COM10  /   L0,          L1STAK(39),  LBASE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM16  /
C
      INTEGER             LINES
C
      COMMON / COM16  /   LINES(2,299)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM17  /
C
      INTEGER             ERROUT,      F4OUT,       INPUT,       SFOUT
C
      COMMON / COM17  /   ERROUT,      F4OUT,       INPUT,       SFOUT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM18  /
C
      LOGICAL             DEBUG,       NOSFL,       PRETTY
C
      COMMON / COM18  /   DEBUG,       NOSFL,       PRETTY
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM24  /
C
      INTEGER             FIND,        LOCATE,      SCAN
C
      COMMON / COM24  /   FIND,        LOCATE,      SCAN
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM25  /
C
      INTEGER             DEFINE,      DOCASE,      DOFOR,       DOWITH
      INTEGER             ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      INTEGER             ONCE,        PROC,        UNTIL,       WHILE
C
      COMMON / COM25  /   DEFINE,      DOCASE,      DOFOR,       DOWITH
      COMMON / COM25  /   ELSEIF,      FOREVR,      IFELSE,      IFTHEN
      COMMON / COM25  /   ONCE,        PROC,        UNTIL,       WHILE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM27  /
C
      INTEGER             LNAME,       LNAMES,      MAXTAB,      MNAMES
      INTEGER             NAMENO,      NAMTAB,      NNAMES,      USES
      INTEGER             DEFS
C
      COMMON / COM27  /   LNAME,       LNAMES(299), MAXTAB,      MNAMES
      COMMON / COM27  /   NAMENO,      NAMTAB(2099),NNAMES
      COMMON / COM27  /   USES(299),   DEFS(299)
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM31  /
C
      INTEGER             NS,          NSMAX,       STMT
C
      COMMON / COM31  /   NS,          NSMAX,       STMT(1326)
C
C
      NX0016=IFUNCT
      IF (NX0016.LT.1.OR.NX0016.GT.15) GO TO 20016
      GO TO (20001,20002,20003,20004,20005,20006,20007,20008,20009,20010
     X,20011,20012,20013,20014,20015), NX0016
20001 ASSIGN 20018 TO NPR001
      GO TO 30001
20018 GO TO 20017
20002 ASSIGN 20019 TO NPR002
      GO TO 30002
20019 GO TO 20017
20003 ASSIGN 20020 TO NPR003
      GO TO 30003
20020 GO TO 20017
20004 ASSIGN 20021 TO NPR004
      GO TO 30004
20021 GO TO 20017
20005 ASSIGN 20022 TO NPR005
      GO TO 30005
20022 GO TO 20017
20006 ASSIGN 20023 TO NPR006
      GO TO 30006
20023 GO TO 20017
20007 ASSIGN 20024 TO NPR007
      GO TO 30007
20024 GO TO 20017
20008 ASSIGN 20025 TO NPR008
      GO TO 30008
20025 GO TO 20017
20009 ASSIGN 20026 TO NPR009
      GO TO 30009
20026 GO TO 20017
20010 ASSIGN 20027 TO NPR010
      GO TO 30010
20027 GO TO 20017
20011 ASSIGN 20028 TO NPR011
      GO TO 30011
20028 GO TO 20017
20012 ASSIGN 20029 TO NPR012
      GO TO 30012
20029 GO TO 20017
20013 ASSIGN 20030 TO NPR012
      GO TO 30012
20030 GO TO 20017
20014 ASSIGN 20031 TO NPR013
      GO TO 30013
20031 GO TO 20017
20015 ASSIGN 20032 TO NPR014
      GO TO 30014
20032 CONTINUE
20016 CONTINUE
C
20017 RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('CASE')
30003 ASSIGN 20033 TO NPR015
      GO TO 30015
20033 IF (.NOT.(FND)) GO TO 20034
      IF (.NOT.(LEVEL.GT.0)) GO TO 20037
      IF (.NOT.(STRCTS(LEVEL) .EQ. DOCASE)) GO TO 20040
      IF (.NOT.(CASENO .LE. CASES(LEVEL))) GO TO 20043
      S1=S1STAK(LEVEL)+CASENO
      INDENT=LEVEL-1
      ASSIGN 20046 TO NPR016
      GO TO 30016
20046 IF (OTHERS(LEVEL)) CALL SFTERR (1,
     X22H(CASE follows IF-NONE))
      IF (.NOT.(CASENO.GT.1 .AND. .NOT.NOFLOW)) GO TO 20047
      S2=S1STAK(LEVEL)+CASES(LEVEL)+2
      ASSIGN 20050 TO NPR017
      GO TO 30017
20050 CONTINUE
20047 CONTINUE
20048 ASSIGN 20051 TO NPR018
      GO TO 30018
20051 S1PNDG=S1
      GO TO 20044
20043 CALL SFTERR (1,21H(CASE number too big))
20044 CONTINUE
20045 GO TO 20041
20040 CALL SFTERR (1,
     X35H(CASE not within DO-CASE structure))
20041 CONTINUE
20042 GO TO 20038
20037 CALL SFTERR (1,23H(CASE found at level 0))
20038 CONTINUE
20039 CONTINUE
20034 CONTINUE
20035 FOUND=.TRUE.
      GO TO 20020
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('CYCLE')
30013 CALL DOCYCL(1)
      FOUND=.TRUE.
      GO TO 20031
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('DEFINITION')
30011 ASSIGN 20052 TO NPR019
      GO TO 30019
20052 IF (.NOT.(FND .AND. .NOT.MORE)) GO TO 20053
      SFNMBR=NONE
      INDENT=0
      ASSIGN 20056 TO NPR016
      GO TO 30016
20056 ASSIGN 20057 TO NPR020
      GO TO 30020
20057 IF (LEVEL.NE.0) CALL SFTERR (1,
     X44H(Missing END(s):  DEFINITION not at level 0))
      LEVEL=1
      IF (DEFS(NAMENO) .EQ. DEFINE) CALL SFTERR (1,
     X34H(Name already used for DEFINITION))
      IF (DEFS(NAMENO) .EQ. DEFINE) CALL SFTERR (1,
     X33H(Name already used for PROCEDURE) )
      DEFS(NAMENO)=DEFINE
      IF (USES(NAMENO) .EQ. PROC) CALL SFTERR (1,
     X35H(Name already used in DO-PROCEDURE))
      STRCTS(LEVEL)=DEFINE
      OUT=HOLDIO
      DEFNO=NAMENO
      LINES(1,DEFNO)=NHELD+1
20053 FOUND=.TRUE.
      GO TO 20028
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('ELSE')
30001 IF (.NOT.(.NOT.MORE)) GO TO 20058
      IF (.NOT.(LEVEL.GT.0)) GO TO 20061
      FND = STRCTS(LEVEL).EQ.IFTHEN .OR. STRCTS(LEVEL)
     X.EQ.ELSEIF
      IF (.NOT.(FND)) GO TO 20064
      INDENT=LEVEL-1
      ASSIGN 20067 TO NPR016
      GO TO 30016
20067 S1=S1STAK(LEVEL)
      S2=S1+1
      IF (.NOT.(.NOT.NOFLOW)) GO TO 20068
      ASSIGN 20071 TO NPR017
      GO TO 30017
20071 CONTINUE
20068 ASSIGN 20072 TO NPR018
      GO TO 30018
20072 IF (.NOT.(STRCTS(LEVEL).EQ.IFTHEN)) GO TO 20073
      S1PNDG=S1
      GO TO 20074
20073 S1PNDG=L1STAK(LEVEL)
20074 S1STAK(LEVEL)=S2
      STRCTS(LEVEL)=IFELSE
      GO TO 20065
20064 IF (.NOT.(STRCTS(LEVEL) .EQ. IFELSE)) GO TO 20076
      CALL SFTERR (1,
     X23H(Multiple ELSE ignored))
      GO TO 20077
20076 CALL SFTERR (1,
     X35H(ELSE not within IF-THEN structure))
20077 CONTINUE
20065 GO TO 20062
20061 CALL SFTERR (1,23H(ELSE found at level 0))
20062 CONTINUE
20058 FOUND=.TRUE.
      GO TO 20018
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('ELSEIF')
30014 ASSIGN 20079 TO NPR021
      GO TO 30021
20079 FND=FND .AND. MORE
      FND=FND .AND. SCANER(FIND,4HTHEN,4)
      IF (.NOT.(FND)) GO TO 20080
      IF (.NOT.(LEVEL.GT.0)) GO TO 20083
      INDENT=LEVEL-1
      ASSIGN 20086 TO NPR016
      GO TO 30016
20086 FND = STRCTS(LEVEL).EQ.IFTHEN .OR. STRCTS(LEVEL)
     X.EQ.ELSEIF
      IF (.NOT.(FND)) GO TO 20087
      S1=S1STAK(LEVEL)
      S2=S1+1
      IF (.NOT.(.NOT.NOFLOW)) GO TO 20090
      ASSIGN 20093 TO NPR017
      GO TO 30017
20093 CONTINUE
20090 IF (.NOT.(STRCTS(LEVEL).EQ.IFTHEN)) GO TO 20094
      STRCTS(LEVEL)=ELSEIF
      GO TO 20095
20094 S1=L1STAK(LEVEL)
20095 S2=L0+1
      ASSIGN 20097 TO NPR022
      GO TO 30022
20097 L0=S2
      L1STAK(LEVEL)=S2
      GO TO 20088
20087 IF (.NOT.(STRCTS(LEVEL).EQ.IFELSE)) GO TO 20098
      CALL SFTERR (1,
     X26H(ELSEIF occurs after ELSE))
      GO TO 20099
20098 CALL SFTERR (1,
     X37H(ELSEIF not within IF-THEN structure))
20099 CONTINUE
20088 GO TO 20084
20083 CALL SFTERR(1,25H(ELSEIF found at level 0))
20084 CONTINUE
20080 FOUND=.TRUE.
      GO TO 20032
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('ENTRY')
30009 IF (.NOT.(.NOT.SCANER (LOCATE,1H=,1))) GO TO 20101
      ASSIGN 20104 TO NPR018
      GO TO 30018
20104 IF (LEVEL.NE.0) CALL SFTERR (1,
     X32H(Entry point must be at level 0))
20101 FOUND=.TRUE.
      GO TO 20026
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('EXIT')
30006 CALL DOEXIT(1)
      FOUND=.TRUE.
      GO TO 20023
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('INCLUDE')
30010 ASSIGN 20105 TO NPR019
      GO TO 30019
20105 IF (.NOT.(FND .AND. .NOT.MORE)) GO TO 20106
      SFNMBR=NONE
      ASSIGN 20109 TO NPR016
      GO TO 30016
20109 ASSIGN 20110 TO NPR023
      GO TO 30023
20110 ASSIGN 20111 TO NPR020
      GO TO 30020
20111 IF (USES(NAMENO) .EQ. DEFINE) CALL SFTERR (1,
     X30H(Name already used in INCLUDE))
      IF (USES(NAMENO) .EQ. PROC) CALL SFTERR (1,
     X35H(Name already used in DO-PROCEDURE))
      USES(NAMENO)=DEFINE
      IF (OUT.EQ.HOLDIO) CALL SFTERR (1,
     X32H(INCLUDE nested in a DEFINITION))
20106 FOUND=.TRUE.
      GO TO 20027
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('OTHERWISE')
30007 IF (.NOT.(.NOT.MORE)) GO TO 20112
      IF (.NOT.(LEVEL.GT.0)) GO TO 20115
      IF (.NOT.(STRCTS(LEVEL) .EQ. DOFOR)) GO TO 20118
      IF (.NOT.(.NOT.OTHERS(LEVEL))) GO TO 20121
      INDENT=LEVEL-1
      S1=S1STAK(LEVEL)
      ASSIGN 20124 TO NPR016
      GO TO 30016
20124 S2=S1-2
      ASSIGN 20125 TO NPR017
      GO TO 30017
20125 ASSIGN 20126 TO NPR018
      GO TO 30018
20126 S1PNDG=S1
      OTHERS(LEVEL)=.TRUE.
      GO TO 20122
20121 CALL SFTERR (1,
     X28H(Multiple otherwise ignored))
20122 GO TO 20119
20118 CALL SFTERR (1,
     X39H(OTHERWISE not within DO-FOR structure))
20119 GO TO 20116
20115 CALL SFTERR (1,28H(OTHERWISE found at level 0))
20116 CONTINUE
20112 FOUND=.TRUE.
      GO TO 20024
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('PROCEDURE')
30002 ASSIGN 20127 TO NPR019
      GO TO 30019
20127 IF (.NOT.(FND .AND. .NOT.MORE)) GO TO 20128
      ASSIGN 20131 TO NPR020
      GO TO 30020
20131 S1=PBASE+NAMENO
      ASSIGN 20132 TO NPR018
      GO TO 30018
20132 S1PNDG=S1
      INDENT=0
      ASSIGN 20133 TO NPR016
      GO TO 30016
C               DO (Output SFTRAN Statement as a FORTRAN Comment)
20133 IF (LEVEL.NE.0) CALL SFTERR (1,
     X43H(Missing END(s):  PROCEDURE not at level 0))
      LEVEL=1
      IF (DEFS(NAMENO) .EQ. PROC) CALL SFTERR (1,
     X33H(Name already used for PROCEDURE) )
      IF (DEFS(NAMENO) .EQ. DEFINE) CALL SFTERR (1,
     X34H(Name already used for DEFINITION))
      DEFS(NAMENO)=PROC
      IF (USES(NAMENO) .EQ. DEFINE) CALL SFTERR (1,
     X30H(Name already used by INCLUDE))
      USES(NAMENO)=PROC
      STRCTS(LEVEL)=PROC
      S1STAK(LEVEL)=P2BASE+NAMENO
20128 FOUND=.TRUE.
      GO TO 20019
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('STOP' or 'RETURN')
30012 IF (.NOT.(.NOT.SCANER (LOCATE,1H=,1))) GO TO 20134
      UNDENT = 999
      ASSIGN 20137 TO NPR024
      GO TO 30024
20137 ASSIGN 20138 TO NPR023
      GO TO 30023
20138 XLATED=.TRUE.
      UNDENT = 0
20134 FOUND=.TRUE.
      GO TO NPR012, (20029,20030)
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('UNTIL')
30005 ASSIGN 20139 TO NPR021
      GO TO 30021
20139 IF (.NOT.(FND .AND. .NOT.MORE)) GO TO 20140
      IF (.NOT.(LEVEL.GT.0)) GO TO 20143
      IF (.NOT.(STRCTS(LEVEL) .EQ. DOWITH)) GO TO 20146
      INDENT=LEVEL-1
      ASSIGN 20149 TO NPR016
      GO TO 30016
20149 IF (EXITS(LEVEL)) CALL SFTERR (1,
     X29H(Multiple EXITs from DO-WITH))
      EXITS(LEVEL)=.TRUE.
      S1=0
      S2=S1STAK(LEVEL)
      ASSIGN 20150 TO NPR025
      GO TO 30025
20150 GO TO 20147
20146 CALL SFTERR (1,
     X36H(UNTIL not within DO-WITH structure))
20147 GO TO 20144
20143 CALL SFTERR (1,24H(UNTIL found at level 0))
20144 CONTINUE
20140 FOUND=.TRUE.
      GO TO 20022
C
C-----------------------------------------------------------------------
C---- PROCEDURE ('WHILE')
30004 ASSIGN 20151 TO NPR021
      GO TO 30021
20151 IF (.NOT.(FND .AND. .NOT.MORE)) GO TO 20152
      IF (.NOT.(LEVEL.GT.0)) GO TO 20155
      IF (.NOT.(STRCTS(LEVEL) .EQ. DOWITH)) GO TO 20158
      INDENT=LEVEL-1
      ASSIGN 20161 TO NPR016
      GO TO 30016
20161 IF (EXITS(LEVEL)) CALL SFTERR (1,
     X29H(Multiple EXITs from DO-WITH))
      EXITS(LEVEL)=.TRUE.
      S1=0
      S2=S1STAK(LEVEL)
      ASSIGN 20162 TO NPR022
      GO TO 30022
20162 GO TO 20159
20158 CALL SFTERR (1,
     X36H(WHILE not within DO-WITH structure))
20159 GO TO 20156
20155 CALL SFTERR (1,24H(WHILE found at level 0))
20156 CONTINUE
20152 FOUND=.TRUE.
      GO TO 20021
C
C-----------------------------------------------------------------------
C---- PROCEDURE (CASE-OTHER)
30026 IF (.NOT.(.NOT.MORE)) GO TO 20163
      IF (.NOT.(LEVEL.GT.0)) GO TO 20166
      IF (.NOT.(STRCTS(LEVEL).EQ.DOCASE)) GO TO 20169
      IF (.NOT.(.NOT.OTHERS(LEVEL))) GO TO 20172
      S1=S1STAK(LEVEL)+CASES(LEVEL)+1
      INDENT=LEVEL-1
      ASSIGN 20175 TO NPR016
      GO TO 30016
20175 IF (.NOT.(.NOT.NOFLOW)) GO TO 20176
      S2=S1+1
      ASSIGN 20179 TO NPR017
      GO TO 30017
20179 CONTINUE
20176 ASSIGN 20180 TO NPR018
      GO TO 30018
20180 S1PNDG=S1
      OTHERS(LEVEL)=.TRUE.
      GO TO 20173
20172 CALL SFTERR (1,
     X29H(Multiple CASE-OTHER ignored))
20173 GO TO 20170
20169 CALL SFTERR (1,
     X41H(CASE-OTHER not within DO-CASE structure))
20170 GO TO 20167
20166 CALL SFTERR (1,29H(CASE-OTHER found at level 0))
20167 CONTINUE
20163 GO TO 20184
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check for '(LOGIC)' Next)
30021 CALL CLOGNX
      GO TO NPR021, (20079,20139,20151)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check for '(NAME)' Next)
30019 CALL CNAMNX
      GO TO NPR019, (20052,20105,20127)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check for CASE Number Next)
30015 IF (.NOT.(SCANER(FIND,5HOTHER,5))) GO TO 20181
      ASSIGN 20184 TO NPR026
      GO TO 30026
20184 FND=.FALSE.
      GO TO 20182
20181 CCNUM = CCMORE
20185 IF (.NOT.(MORE)) GO TO 20186
      LJUNK = SCANER(SCAN,DUMMY,CCMORE+1)
      GO TO 20185
20186 FND = DCODE(STMT,CCNUM,CCMORE,CASENO)
      FND=FND .AND. CASENO.GT.0
20182 GO TO 20033
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'GO TO S2')
30017 CALL GOTOS2
      GO TO NPR017, (20050,20071,20093,20125,20179)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'S1 IF (.NOT.(LOGIC)) GO TO S2')
30022 CALL GIFNLG
      GO TO NPR022, (20097,20162)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Generate 'S1 IF (LOGIC) GO TO S2')
30025 CALL GIFLOG
      GO TO 20150
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Get PROCEDURE/Definition Name Number)
30020 CALL GNAMNO
      GO TO NPR020, (20057,20111,20131)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output 'S1PNDG CONTINUE')
30018 CALL OPNCNT
      GO TO NPR018, (20051,20072,20104,20126,20132,20180)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output SFTRAN Statement to List File)
30016 CALL OSFLST
      GO TO NPR016, (20046,20056,20067,20086,20109,20124,20133,20149,201
     X61,20175)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output Statement to FORTRAN File)
30023 CALL OSFRFL
      GO TO NPR023, (20110,20138)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Output Statement to List File)
30024 IF (.NOT.NOSFL) CALL IOFUNC (SFOUT,STMT,NS)
      GO TO 20137
C
C-----------------------------------------------------------------------
C---- PROCEDURE (READ/WRITE Statement)
30008 CALL PRRDWR
      FOUND = .TRUE.
      GO TO 20025
C
      END
